Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java	(revision 28964)
@@ -249,5 +249,5 @@
 		Element param_list = doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
 		//put them in
-		GSXML.addParametersToList(doc, param_list, subset_params);
+		GSXML.addParametersToList(param_list, subset_params);
 		metadata_request.appendChild(param_list);
 		//create the message
@@ -286,5 +286,5 @@
 		// passed in as a parameter
 		
-		Document doc = this.converter.newDOM();
+		Document doc = XMLConverter.newDOM();
 		
 		Element mr_format_message = doc.createElement(GSXML.MESSAGE_ELEM);
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java	(revision 28964)
@@ -24,5 +24,5 @@
 	{
 
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 		Document doc = message.getOwnerDocument();
 		
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java	(revision 28964)
@@ -30,5 +30,5 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 		Document doc = message.getOwnerDocument();
 		
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DepositorAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DepositorAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DepositorAction.java	(revision 28964)
@@ -288,5 +288,5 @@
 				{
 					ex.printStackTrace();
-					GSXML.addError(doc, responseMessage, "Failed to copy the deposited file into the collection.");
+					GSXML.addError(responseMessage, "Failed to copy the deposited file into the collection.");
 					return responseMessage;
 				}
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java	(revision 28964)
@@ -81,5 +81,5 @@
 		// for now, no subaction eventually we may want to have subactions such as text assoc or something ?
 
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 		Document doc = message.getOwnerDocument();
 		
@@ -212,5 +212,5 @@
 		if (service_params != null)
 		{
-			GSXML.addParametersToList(doc, ds_param_list, service_params);
+			GSXML.addParametersToList(ds_param_list, service_params);
 		}
 
@@ -394,5 +394,5 @@
 		if (service_params != null)
 		{
-			GSXML.addParametersToList(doc, dm_param_list, service_params);
+			GSXML.addParametersToList(dm_param_list, service_params);
 		}
 
@@ -424,5 +424,5 @@
 		if (service_params != null)
 		{
-			GSXML.addParametersToList(doc, doc_meta_param_list, service_params);
+			GSXML.addParametersToList(doc_meta_param_list, service_params);
 		}
 
@@ -482,5 +482,5 @@
 		if (service_params != null)
 		{
-			GSXML.addParametersToList(doc, dc_param_list, service_params);
+			GSXML.addParametersToList(dc_param_list, service_params);
 		}
 
@@ -570,5 +570,5 @@
 					{
 						Element enrich_pl = doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-						GSXML.addParametersToList(doc, enrich_pl, e_service_params);
+						GSXML.addParametersToList(enrich_pl, e_service_params);
 						enrich_request.appendChild(enrich_pl);
 					}
@@ -820,5 +820,5 @@
 
 		Element query_param_list = doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		GSXML.addParametersToList(doc, query_param_list, service_params);
+		GSXML.addParametersToList(query_param_list, service_params);
 		mr_query_request.appendChild(query_param_list);
 
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java	(revision 28964)
@@ -40,5 +40,5 @@
     public Node process (Node message_node) {
 	
-	    Element message = this.converter.nodeToElement(message_node);
+	    Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java	(revision 28964)
@@ -30,5 +30,5 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java	(revision 28964)
@@ -30,5 +30,5 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    
@@ -104,5 +104,5 @@
 			{
 				param_list = doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-				GSXML.addParametersToList(doc, param_list, service_params);
+				GSXML.addParametersToList(param_list, service_params);
 				mr_query_request.appendChild(param_list);
 			}
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java	(revision 28964)
@@ -37,5 +37,5 @@
 	{
 
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    
@@ -103,5 +103,5 @@
 		}
 		Element query_param_list = doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		GSXML.addParametersToList(doc, query_param_list, service_params);
+		GSXML.addParametersToList(query_param_list, service_params);
 
 		// we will do a query for each coll
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java	(revision 28964)
@@ -9,4 +9,5 @@
 import org.greenstone.gsdl3.util.GSXML;
 import org.greenstone.gsdl3.util.UserContext;
+import org.greenstone.gsdl3.util.XMLConverter;
 import org.greenstone.util.GlobalProperties;
 import org.w3c.dom.Document;
@@ -26,6 +27,6 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
-		Document doc = this.converter.newDOM();
+		Element message = GSXML.nodeToElement(message_node);
+		Document doc = XMLConverter.newDOM();
 	    
 		Element request = (Element) GSXML.getChildByTagName(message, GSXML.REQUEST_ELEM);
@@ -89,5 +90,5 @@
   protected Element homePage(Element request)
 	{
-	  Document doc = this.converter.newDOM();
+	  Document doc = XMLConverter.newDOM();
 		
 		UserContext userContext = new UserContext(request);
@@ -154,5 +155,5 @@
 	protected Element aboutPage(Element request)
 	{
-	  Document doc = this.converter.newDOM();
+	  Document doc = XMLConverter.newDOM();
 		
 		UserContext userContext = new UserContext(request);
@@ -238,5 +239,5 @@
 	protected Element unknownPage(Element request)
 	{
-	  Document doc = this.converter.newDOM();
+	  Document doc = XMLConverter.newDOM();
 		
 		UserContext userContext = new UserContext(request);
@@ -326,5 +327,5 @@
 	protected Element gli4gs3Page(Element request)
 	{
-	  Document doc = this.converter.newDOM();
+	  Document doc = XMLConverter.newDOM();
 		
 		String lang = request.getAttribute(GSXML.LANG_ATT);
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java	(revision 28964)
@@ -21,5 +21,5 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    
@@ -90,5 +90,5 @@
 				{
 					param_list = doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-					GSXML.addParametersToList(doc, param_list, service_params);
+					GSXML.addParametersToList(param_list, service_params);
 				}
 
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/QueryAction.java	(revision 28964)
@@ -27,5 +27,5 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    
@@ -121,5 +121,5 @@
 
 		Element query_param_list = doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
-		GSXML.addParametersToList(doc, query_param_list, service_params);
+		GSXML.addParametersToList(query_param_list, service_params);
 		mr_query_request.appendChild(query_param_list);
 
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/RSSAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/RSSAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/RSSAction.java	(revision 28964)
@@ -27,5 +27,5 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/SystemAction.java	(revision 28964)
@@ -29,5 +29,5 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    
Index: main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java
===================================================================
--- main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java	(revision 28958)
+++ main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/XMLDocumentAction.java	(revision 28964)
@@ -28,5 +28,5 @@
 	public Node process(Node message_node)
 	{
-		Element message = this.converter.nodeToElement(message_node);
+		Element message = GSXML.nodeToElement(message_node);
 	    Document doc = message.getOwnerDocument();
 	    