Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 28987)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/core/MessageRouter.java	(revision 28988)
@@ -36,5 +36,4 @@
 import org.greenstone.gsdl3.util.GSPath;
 import org.greenstone.gsdl3.util.GSXML;
-import org.greenstone.gsdl3.util.OAIXML;
 import org.greenstone.gsdl3.util.UserContext;
 import org.greenstone.gsdl3.util.XMLConverter;
@@ -88,8 +87,4 @@
 	/** list of collections that are loaded but are private */
 	protected Element private_collection_list = null;
-
-	/** list of collections that are public and OAI-supportive */
-	protected Element oai_collection_list = null;
-
 	/** list of service clusters that can be reached */
 	protected Element cluster_list = null;
@@ -101,7 +96,4 @@
 	protected Element metadata_list = null;
 
-	/** a converter class to parse XML and create Docs */
-	protected XMLConverter converter = null;
-
 	//***************************************************************
 	// public methods
@@ -111,5 +103,4 @@
 	public MessageRouter()
 	{
-		this.converter = new XMLConverter();
 	}
 
@@ -218,8 +209,8 @@
 	{
 
-		Document doc = this.converter.getDOM(xml_in);
+		Document doc = XMLConverter.getDOM(xml_in);
 
 		Node result = process(doc);
-		return this.converter.getString(result);
+		return XMLConverter.getString(result);
 	}
 
@@ -333,5 +324,5 @@
 					else
 					{
-						logger.error("MessageRouter Error: request has illegal module name in:\n" + this.converter.getString(req));
+						logger.error("MessageRouter Error: request has illegal module name in:\n" + XMLConverter.getString(req));
 					}
 				}
@@ -341,5 +332,5 @@
 
 		logger.debug("MR returned response");
-		logger.debug(this.converter.getString(mainResult));
+		logger.debug(XMLConverter.getString(mainResult));
 
 		return mainResult;
@@ -391,5 +382,5 @@
 	protected void cleanUpModuleMapSubset(Element list, String remote_site)
 	{
-		logger.error(this.converter.getString(list));
+		logger.error(XMLConverter.getString(list));
 		NodeList elements = list.getChildNodes(); // we are assuming no extraneous nodes
 		for (int i = elements.getLength() - 1; i >= 0; i--)
@@ -416,5 +407,5 @@
 			}
 		}
-		logger.error(this.converter.getString(list));
+		logger.error(XMLConverter.getString(list));
 	}
 
@@ -454,5 +445,5 @@
 		}
 
-		Document config_doc = this.converter.getDOM(configFile);
+		Document config_doc = XMLConverter.getDOM(configFile);
 		if (config_doc == null)
 		{
@@ -477,5 +468,4 @@
 		this.collection_list = doc.createElement(GSXML.COLLECTION_ELEM + GSXML.LIST_MODIFIER);
 		this.private_collection_list = doc.createElement(GSXML.COLLECTION_ELEM + GSXML.LIST_MODIFIER);
-		this.oai_collection_list = doc.createElement(GSXML.COLLECTION_ELEM + GSXML.LIST_MODIFIER);
 		configureCollections();
 
@@ -687,5 +677,5 @@
 		if (init_file.exists())
 		{
-			Document init_doc = this.converter.getDOM(init_file);
+			Document init_doc = XMLConverter.getDOM(init_file);
 			if (init_doc != null)
 			{
@@ -730,16 +720,4 @@
 				// add short description_ to collection_list_
 				this.collection_list.appendChild(e);
-
-				if (c.hasOAI())
-				{
-					Element ane = doc.createElement(GSXML.COLLECTION_ELEM);
-					ane.setAttribute(GSXML.NAME_ATT, col_name);
-					ane.setAttribute(OAIXML.LASTMODIFIED, "" + c.getLastmodified());
-					// lastmodified not of use anymore for OAI, perhaps useful as general information
-					ane.setAttribute(OAIXML.EARLIEST_DATESTAMP, "" + c.getEarliestDatestamp()); // for OAI
-
-					this.oai_collection_list.appendChild(ane);
-				}
-
 			}
 			else
@@ -804,5 +782,5 @@
 			return false;
 		}
-		Document config_doc = this.converter.getDOM(configFile);
+		Document config_doc = XMLConverter.getDOM(configFile);
 		if (config_doc == null)
 		{
@@ -1003,12 +981,4 @@
 						this.collection_list.removeChild(this_col);
 					}
-					if (((Collection) m).hasOAI())
-					{
-						this_col = GSXML.getNamedElement(this.oai_collection_list, GSXML.COLLECTION_ELEM, GSXML.NAME_ATT, name);
-						if (this_col != null)
-						{
-							this.oai_collection_list.removeChild(this_col);
-						}
-					}
 				}
 				else
@@ -1050,5 +1020,5 @@
 					cleanUpModuleMapSubset(this.service_list, name);
 
-					// can remote collections be in the oai_coll list, or private coll list ??
+					// can remote collections be in the private coll list ??
 				}
 			}
@@ -1139,13 +1109,4 @@
 		}
 
-		if (type.equals(OAIXML.OAI_SET_LIST))
-		{
-			logger.info("oaiSetList request received");
-			//this is the oai receptionist asking for a list of oai-support collections
-			response.setAttribute(GSXML.TYPE_ATT, OAIXML.OAI_SET_LIST);
-			response.appendChild(doc.importNode(this.oai_collection_list, true));
-			return response;
-		}
-
 		if (type.equals(GSXML.REQUEST_TYPE_SYSTEM))
 		{
@@ -1226,5 +1187,5 @@
 									continue;
 								}
-								Document site_config_doc = this.converter.getDOM(configFile);
+								Document site_config_doc = XMLConverter.getDOM(configFile);
 								if (site_config_doc == null)
 								{
@@ -1324,5 +1285,5 @@
 		String eol = System.getProperty("line.separator");
 
-		String mess = "Can't process request:" + eol + "  " + this.converter.getString(req);
+		String mess = "Can't process request:" + eol + "  " + XMLConverter.getString(req);
 		logger.error(mess);
 		return null;
@@ -1342,5 +1303,5 @@
 		if (commands == null)
 		{
-			logger.error("no commands, " + converter.getPrettyString(request));
+			logger.error("no commands, " + XMLConverter.getPrettyString(request));
 			return response;
 		}