Index: main/trunk/gli/classes/dictionary.properties
===================================================================
--- main/trunk/gli/classes/dictionary.properties	(revision 29008)
+++ main/trunk/gli/classes/dictionary.properties	(revision 29009)
@@ -940,4 +940,24 @@
 #**********************
 #
+#***** FormatConversionDialog *****
+FormatConversionDialog.Title:Convert Greenstone 2 format statements to Greenstone 3
+FormatConversionDialog.Reconvert:Reconvert
+FormatConversionDialog.XHTML_Tidy:XHTML Tidy
+FormatConversionDialog.XHTML_Tidy_Tooltip:Will run HTML Tidy over the Greenstone3 format statement to try to fix up obvious XHTML errors.
+FormatConversionDialog.Next:Next
+FormatConversionDialog.Accept_All:Accept All
+FormatConversionDialog.GS2_Text_Tooltip:Greenstone2 format statement
+FormatConversionDialog.GS3_Text_Tooltip:Greenstone3 format statement, must be XML to be active in Greenstone.
+FormatConversionDialog.Tidy_Failed:Tidy failed.
+FormatConversionDialog.Tidy_Done:Tidy done.
+FormatConversionDialog.XML_Still_Invalid:XML is still invalid.
+FormatConversionDialog.Error_GS3_Format:Error in GS3 format statement.
+FormatConversionDialog.Invalid_XML:Invalid XML.
+FormatConversionDialog.Invalid_XML_Warning_Title:Cancel or Continue?
+FormatConversionDialog.Cancel_Or_Continue_Next:Either press Cancel to go back and re-edit the XML.\nOr press OK to store the current XML as-is, albeit inactive, and continue on to the next statement.\nYou can later use the Format tab to revisit this format statement if you want to update its syntax.
+FormatConversionDialog.Cancel_Or_Accept_All:One or more GS3 format statements contains invalid XML.\nEither press Cancel to correct the XML.\nOr press OK to store the GS3 format statements as-is, albeit inactive.\nYou can later use the Format tab to revisit the format statements if you want to update their syntax.
+
+#**********************
+#
 #***** Options Pane inside CreatePane *****
 OptionsPane.Cancelled: - cancelled
Index: main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java
===================================================================
--- main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java	(revision 29008)
+++ main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java	(revision 29009)
@@ -68,4 +68,8 @@
     
     // widgets
+    final String WARNING_TITLE = Dictionary.get("General.Warning") 
+	+ ": " + Dictionary.get("FormatConversionDialog.Invalid_XML")
+	+ " " + Dictionary.get("FormatConversionDialog.Invalid_XML_Warning_Title");
+
     private static final Border EMPTYBORDER = new EmptyBorder(5, 5, 5, 5);
     private JLabel section_label = null;
@@ -92,5 +96,5 @@
 	this.setComponentOrientation(Dictionary.getOrientation());
 	setSize(SIZE);
-	setTitle(Dictionary.get("FormatConversionDialog.Title"));
+	setTitle(Dictionary.get(Dictionary.get("FormatConversionDialog.Title")));
 	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
 	
@@ -98,10 +102,10 @@
 	JPanel midbutton_panel = new JPanel(); // FlowLayout by default in a JPanel
 	midbutton_panel.setComponentOrientation(Dictionary.getOrientation());
-	JButton reconvert_button = new JButton("Reconvert");
+	JButton reconvert_button = new JButton(Dictionary.get("FormatConversionDialog.Reconvert"));
 	midbutton_panel.add(reconvert_button);
 	reconvert_button.addActionListener(new ReconvertListener());
 	reconvert_button.setAlignmentY(Component.CENTER_ALIGNMENT);
 
-	section_label = new JLabel("Section Label Goes Here");
+	section_label = new JLabel("Section Label Goes Here"); // title will be replaced, don't need to translate
 	section_label.setBorder(EMPTYBORDER);
 	section_label.setComponentOrientation(Dictionary.getOrientation());
@@ -109,13 +113,14 @@
 	JPanel button1_panel = new JPanel();
 	button1_panel.setComponentOrientation(Dictionary.getOrientation());
-	undo_button = new JButton("Undo");
+	undo_button = new JButton(Dictionary.get("General.Undo"));
 	undo_button.addActionListener(new UndoListener());
 	undo_button.setEnabled(false);
 
-	redo_button = new JButton("Redo");
+	redo_button = new JButton(Dictionary.get("General.Redo"));
 	redo_button.addActionListener(new RedoListener());
 	redo_button.setEnabled(false);
 
-	xmltidy_button = new JButton("XHTML Tidy");
+	xmltidy_button = new JButton(Dictionary.get("FormatConversionDialog.XHTML_Tidy"));
+	xmltidy_button.setToolTipText(Dictionary.get("FormatConversionDialog.XHTML_Tidy_Tooltip"));
 	xmltidy_button.addActionListener(new XMLTidyButtonListener());
 
@@ -126,8 +131,8 @@
 	JPanel button_panel = new JPanel(new FlowLayout());
 	button_panel.setComponentOrientation(Dictionary.getOrientation());
-	count_label = new JLabel("<count>");
-	cancel_button = new JButton("Cancel");
-	next_button = new JButton("Next");
-	accept_all_button = new JButton("Accept All");
+	count_label = new JLabel("<count>"); // placeholder text for numbers, no need to translate
+	cancel_button = new JButton(Dictionary.get("General.Cancel"));
+	next_button = new JButton(Dictionary.get("FormatConversionDialog.Next"));
+	accept_all_button = new JButton(Dictionary.get("FormatConversionDialog.Accept_All"));
 	cancel_button.addActionListener(new CancelButtonListener());
 	next_button.addActionListener(new NextButtonListener());
@@ -152,4 +157,6 @@
 	initTextArea(gs2_textarea);
 	initTextArea(gs3_textarea);
+	gs2_textarea.setToolTipText(Dictionary.get("FormatConversionDialog.GS2_Text_Tooltip"));
+	gs3_textarea.setToolTipText(Dictionary.get("FormatConversionDialog.GS2_Text_Tooltip"));
 
 
@@ -212,6 +219,5 @@
 	editor_textarea.setLineWrap(true);
 	editor_textarea.setRows(11);
-	editor_textarea.setWrapStyleWord(false);
-	editor_textarea.setToolTipText(Dictionary.get("CDM.FormatManager.Add_Tooltip"));
+	editor_textarea.setWrapStyleWord(false);	
     }
 
@@ -420,5 +426,6 @@
 	    if(process_exitValue >= 2) {
 		System.err.println("@@@ Process exit value: " + process_exitValue);
-		errorMsg = "Tidy failed. XML is still invalid.";
+		errorMsg = Dictionary.get("FormatConversionDialog.Tidy_Failed") 
+		    + " " + Dictionary.get("FormatConversionDialog.XML_Still_Invalid");
 	    } else {
 		errorMsg = "";
@@ -437,5 +444,6 @@
 	boolean parsed = setGS3Format(i, gs3formatstr); // will parse the gs3formatstr into a DOM object
 	if(!parsed && errorMsg.equals("")) {
-	    errorMsg = "Tidy done. XML is still invalid.";
+	    errorMsg = Dictionary.get("FormatConversionDialog.Tidy_Done")
+		+ " " + Dictionary.get("FormatConversionDialog.XML_Still_Invalid");
 	}	
 	return errorMsg;	
@@ -812,6 +820,6 @@
 
 	    if(!parse_success) { // invalid XML, warn the user
-		String message = "There is an error in the XML. Either press Cancel to go back and re-edit the XML. Or press OK to store the current XML as-is, albeit inactive, and continue on to the next statement. You can later use the Format tab to revisit this format statement if you want to update its syntax.";
-		int user_choice = JOptionPane.showConfirmDialog(FormatConversionDialog.this, message, "Warning: Invalid XML. Continue?", JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
+		String message = Dictionary.get("FormatConversionDialog.Invalid_XML") + " " + Dictionary.get("FormatConversionDialog.Cancel_Or_Continue_Next");
+		int user_choice = JOptionPane.showConfirmDialog(FormatConversionDialog.this, message, WARNING_TITLE, JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
 
 		if(user_choice == JOptionPane.CANCEL_OPTION) {
@@ -850,7 +858,7 @@
 
 	    if(!parse_success) { // invalid XML for current format statement, warn the user
-		setErrorStatus("Invalid XML");
-
-		message = "Invalid XML. Either press Cancel to go back and re-edit the XML. Or press OK to store the current XML as-is, albeit inactive, and continue on to the next statement. You can later use the Format tab to revisit this format statement if you want to update its syntax.";
+		setErrorStatus(Dictionary.get("FormatConversionDialog.Invalid_XML"));
+
+		message = Dictionary.get("FormatConversionDialog.Invalid_XML") + " " + Dictionary.get("FormatConversionDialog.Cancel_Or_Continue_Next");
 	    }
 
@@ -863,10 +871,10 @@
 		if(!validationMsg.startsWith(XMLTools.WELLFORMED)) {
 		    parse_success = false;
-		    message = "One or more GS3 format statements contains invalid XML. Either press Cancel to correct the XML. Or press OK to store the GS3 format statements as-is, albeit inactive. You can later use the Format tab to revisit the format statements if you want to update their syntax.";
+		    message = Dictionary.get("FormatConversionDialog.Cancel_Or_Accept_All");
 		}
 	    }
 
 	    if(!parse_success) {
-		int user_choice = JOptionPane.showConfirmDialog(FormatConversionDialog.this, message, "Warning: Invalid XML. Continue?", JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
+		int user_choice = JOptionPane.showConfirmDialog(FormatConversionDialog.this, message, WARNING_TITLE, JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE);
 		if(user_choice == JOptionPane.CANCEL_OPTION) {
 		    return; // Don't close the dialog. Let the user continue looking at this or subsequent GS3 format statements.
@@ -892,5 +900,5 @@
 	    if(process_exitValue >= 2) {
 		System.err.println("@@@ Process exit value: " + process_exitValue);
-		setErrorStatus("Tidy failed.");
+		setErrorStatus(Dictionary.get("FormatConversionDialog.Tidy_Failed"));
 	    } else {
 		gs3formatstr_notags = htmltidy_string;
@@ -908,7 +916,9 @@
 
 		if(parse_success) {
-		    statusbar.setText("Tidy done.");
+		    statusbar.setText(Dictionary.get("FormatConversionDialog.Tidy_Done"));
 		} else {
-		    setErrorStatus("Tidy done. Error in GS3 format statement. Invalid XML.");
+		    setErrorStatus(Dictionary.get("FormatConversionDialog.Tidy_Done") 
+				   + " " + Dictionary.get("FormatConversionDialog.Error_GS3_Format") 
+				   + " " + Dictionary.get("FormatConversionDialog.Invalid_XML"));
 		}
 	    }