Index: /main/trunk/gli/classes/dictionary.properties
===================================================================
--- /main/trunk/gli/classes/dictionary.properties	(revision 29010)
+++ /main/trunk/gli/classes/dictionary.properties	(revision 29011)
@@ -941,20 +941,24 @@
 #
 #***** FormatConversionDialog *****
-FormatConversionDialog.Title:Convert Greenstone 2 format statements to Greenstone 3
+FormatConversionDialog.Title:Convert Greenstone2 format statements to Greenstone3
 FormatConversionDialog.Reconvert:Reconvert
+FormatConversionDialog.Reconvert_Tooltip:Converts the text that is currently in the Greenstone2 format text area into a Greenstone3 format statement.
 FormatConversionDialog.XHTML_Tidy:XHTML Tidy
 FormatConversionDialog.XHTML_Tidy_Tooltip:Will run HTML Tidy over the Greenstone3 format statement to try to fix up obvious XHTML errors.
 FormatConversionDialog.Next:Next
+FormatConversionDialog.Next_Tooltip:Inspect the next Greenstone3 format statement that has been automatically converted from a Greenstone2 format statement.
 FormatConversionDialog.Accept_All:Accept All
-FormatConversionDialog.GS2_Text_Tooltip:Greenstone2 format statement
+FormatConversionDialog.Accept_All_Tooltip:Closes this dialog, accepting the default Greenstone3 format statements that have been automatically produced for the current and any subsequent Greenstone2 format statements.
+FormatConversionDialog.Cancel_Tooltip:Cancels out of opening the collection and closes this dialog, discarding any changes made in the dialog.
+FormatConversionDialog.GS2_Text_Tooltip:Greenstone2 format statement.
 FormatConversionDialog.GS3_Text_Tooltip:Greenstone3 format statement, must be XML to be active in Greenstone.
 FormatConversionDialog.Tidy_Failed:Tidy failed.
 FormatConversionDialog.Tidy_Done:Tidy done.
 FormatConversionDialog.XML_Still_Invalid:XML is still invalid.
-FormatConversionDialog.Error_GS3_Format:Error in GS3 format statement.
+FormatConversionDialog.Error_GS3_Format:Error in Greenstone3 format statement.
 FormatConversionDialog.Invalid_XML:Invalid XML.
 FormatConversionDialog.Invalid_XML_Warning_Title:Cancel or Continue?
 FormatConversionDialog.Cancel_Or_Continue_Next:Either press Cancel to go back and re-edit the XML.\nOr press OK to store the current XML as-is, albeit inactive, and continue on to the next statement.\nYou can later use the Format tab to revisit this format statement if you want to update its syntax.
-FormatConversionDialog.Cancel_Or_Accept_All:One or more GS3 format statements contains invalid XML.\nEither press Cancel to correct the XML.\nOr press OK to store the GS3 format statements as-is, albeit inactive.\nYou can later use the Format tab to revisit the format statements if you want to update their syntax.
+FormatConversionDialog.Cancel_Or_Accept_All:One or more Greenstone3 format statements contains invalid XML.\nEither press Cancel to correct the XML.\nOr press OK to store the Greenstone3 format statements as-is, albeit inactive.\nYou can later use the Format tab to revisit the format statements if you want to update their syntax.
 
 #**********************
Index: /main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java
===================================================================
--- /main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java	(revision 29010)
+++ /main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java	(revision 29011)
@@ -42,5 +42,6 @@
 // Help tooltips on buttons
 // + Undo, Redo buttons
-// Split class into dialog/widgets and data processing
+// X Split class into dialog/widgets and data processing?
+// http://www.java2s.com/Tutorial/Java/0240__Swing/SettingJOptionPanebuttonlabelstoFrench.htm
 
 public class FormatConversionDialog extends ModalDialog
@@ -97,4 +98,5 @@
 	setSize(SIZE);
 	setTitle(Dictionary.get(Dictionary.get("FormatConversionDialog.Title")));
+	this.addWindowListener(new WindowClosingListener()); // the dialog's top right close button should behave as a Cancel press
 	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
 	
@@ -103,4 +105,5 @@
 	midbutton_panel.setComponentOrientation(Dictionary.getOrientation());
 	JButton reconvert_button = new JButton(Dictionary.get("FormatConversionDialog.Reconvert"));
+	reconvert_button.setToolTipText(Dictionary.get("FormatConversionDialog.Reconvert_Tooltip"));
 	midbutton_panel.add(reconvert_button);
 	reconvert_button.addActionListener(new ReconvertListener());
@@ -135,6 +138,9 @@
 	next_button = new JButton(Dictionary.get("FormatConversionDialog.Next"));
 	accept_all_button = new JButton(Dictionary.get("FormatConversionDialog.Accept_All"));
+	accept_all_button.setToolTipText(Dictionary.get("FormatConversionDialog.Accept_All_Tooltip"));
 	cancel_button.addActionListener(new CancelButtonListener());
+	cancel_button.setToolTipText(Dictionary.get("FormatConversionDialog.Cancel_Tooltip"));
 	next_button.addActionListener(new NextButtonListener());
+	next_button.setToolTipText(Dictionary.get("FormatConversionDialog.Next_Tooltip"));
 	accept_all_button.addActionListener(new AcceptAllButtonListener());
 	button_panel.add(cancel_button);
@@ -158,5 +164,5 @@
 	initTextArea(gs3_textarea);
 	gs2_textarea.setToolTipText(Dictionary.get("FormatConversionDialog.GS2_Text_Tooltip"));
-	gs3_textarea.setToolTipText(Dictionary.get("FormatConversionDialog.GS2_Text_Tooltip"));
+	gs3_textarea.setToolTipText(Dictionary.get("FormatConversionDialog.GS3_Text_Tooltip"));
 
 
@@ -230,4 +236,5 @@
 
 	if(Gatherer.GS3 && collect_cfg_file.getAbsolutePath().endsWith(".xml")) {
+
 	    //System.err.println("*** Opening an xml config file");
 		
@@ -259,4 +266,14 @@
 		}
 		System.err.println("*** Found GS2 format statements in config file to be converted to GS3.");
+
+		
+		// if remote GS3, do we open the collection with the html-encoded GS2 format statements
+		// or do we not allow the remote user to open such a collection at all?
+		// For now we allow them to open it, but print a warning that conversions are not possible.
+		
+		if(Gatherer.isGsdlRemote) { // remote GS3
+		    System.err.println("*** Cannot convert GS2 collections from a remote GS3 server.");	
+		    return OpenCollectionDialog.OK_OPTION;
+		}
 
 		// If we get here, it means there were no CDataSections in the first (any) <gsf:gs2-format/>
@@ -788,4 +805,12 @@
     }
 
+    // windowClosing() is called when the user presses the top-right close button the dialog
+    // this means the user wanted to cancel out of the entire Format Conversion Wizard.
+    private class WindowClosingListener extends WindowAdapter {
+	public void windowClosing(WindowEvent e) {	    
+	    dlgResult = OpenCollectionDialog.CANCEL_OPTION;
+	}
+    }
+
     private class ReconvertListener implements ActionListener {
 	public void actionPerformed(ActionEvent e) {