Index: main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java
===================================================================
--- main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java	(revision 29011)
+++ main/trunk/gli/src/org/greenstone/gatherer/gui/FormatConversionDialog.java	(revision 29012)
@@ -75,11 +75,11 @@
     private static final Border EMPTYBORDER = new EmptyBorder(5, 5, 5, 5);
     private JLabel section_label = null;
-    private JButton cancel_button = null;
-    private JButton next_button = null;
-    private JButton accept_all_button = null;
-    private JButton undo_button = null;
-    private JButton redo_button = null;
-    private JButton htmltidy_button = null;
-    private JButton xmltidy_button = null;
+    private GLIButton cancel_button = null;
+    private GLIButton next_button = null;
+    private GLIButton accept_all_button = null;
+    private GLIButton undo_button = null;
+    private GLIButton redo_button = null;
+    private GLIButton htmltidy_button = null;
+    private GLIButton xmltidy_button = null;
     private NumberedJTextArea gs2_textarea = null;
     private NumberedJTextArea gs3_textarea = null;
@@ -104,6 +104,5 @@
 	JPanel midbutton_panel = new JPanel(); // FlowLayout by default in a JPanel
 	midbutton_panel.setComponentOrientation(Dictionary.getOrientation());
-	JButton reconvert_button = new JButton(Dictionary.get("FormatConversionDialog.Reconvert"));
-	reconvert_button.setToolTipText(Dictionary.get("FormatConversionDialog.Reconvert_Tooltip"));
+	JButton reconvert_button = new GLIButton(Dictionary.get("FormatConversionDialog.Reconvert"), Dictionary.get("FormatConversionDialog.Reconvert_Tooltip"));
 	midbutton_panel.add(reconvert_button);
 	reconvert_button.addActionListener(new ReconvertListener());
@@ -116,14 +115,13 @@
 	JPanel button1_panel = new JPanel();
 	button1_panel.setComponentOrientation(Dictionary.getOrientation());
-	undo_button = new JButton(Dictionary.get("General.Undo"));
+	undo_button = new GLIButton(Dictionary.get("General.Undo"), Dictionary.get("General.Undo_Tooltip"));
 	undo_button.addActionListener(new UndoListener());
 	undo_button.setEnabled(false);
 
-	redo_button = new JButton(Dictionary.get("General.Redo"));
+	redo_button = new GLIButton(Dictionary.get("General.Redo"), Dictionary.get("General.Redo_Tooltip"));
 	redo_button.addActionListener(new RedoListener());
 	redo_button.setEnabled(false);
 
-	xmltidy_button = new JButton(Dictionary.get("FormatConversionDialog.XHTML_Tidy"));
-	xmltidy_button.setToolTipText(Dictionary.get("FormatConversionDialog.XHTML_Tidy_Tooltip"));
+	xmltidy_button = new GLIButton(Dictionary.get("FormatConversionDialog.XHTML_Tidy"), Dictionary.get("FormatConversionDialog.XHTML_Tidy_Tooltip"));
 	xmltidy_button.addActionListener(new XMLTidyButtonListener());
 
@@ -135,12 +133,9 @@
 	button_panel.setComponentOrientation(Dictionary.getOrientation());
 	count_label = new JLabel("<count>"); // placeholder text for numbers, no need to translate
-	cancel_button = new JButton(Dictionary.get("General.Cancel"));
-	next_button = new JButton(Dictionary.get("FormatConversionDialog.Next"));
-	accept_all_button = new JButton(Dictionary.get("FormatConversionDialog.Accept_All"));
-	accept_all_button.setToolTipText(Dictionary.get("FormatConversionDialog.Accept_All_Tooltip"));
+	cancel_button = new GLIButton(Dictionary.get("General.Cancel"), Dictionary.get("FormatConversionDialog.Cancel_Tooltip"));
+	next_button = new GLIButton(Dictionary.get("FormatConversionDialog.Next"), Dictionary.get("FormatConversionDialog.Next_Tooltip"));
+	accept_all_button = new GLIButton(Dictionary.get("FormatConversionDialog.Accept_All"), Dictionary.get("FormatConversionDialog.Accept_All_Tooltip"));
 	cancel_button.addActionListener(new CancelButtonListener());
-	cancel_button.setToolTipText(Dictionary.get("FormatConversionDialog.Cancel_Tooltip"));
 	next_button.addActionListener(new NextButtonListener());
-	next_button.setToolTipText(Dictionary.get("FormatConversionDialog.Next_Tooltip"));
 	accept_all_button.addActionListener(new AcceptAllButtonListener());
 	button_panel.add(cancel_button);
Index: main/trunk/gli/src/org/greenstone/gatherer/gui/OpenCollectionDialog.java
===================================================================
--- main/trunk/gli/src/org/greenstone/gatherer/gui/OpenCollectionDialog.java	(revision 29011)
+++ main/trunk/gli/src/org/greenstone/gatherer/gui/OpenCollectionDialog.java	(revision 29012)
@@ -443,4 +443,11 @@
 	        // will tell the server that the collect directory has changed and that
 			// the workspace needs to be refreshed (Documents in Greenstone Collections)
+
+	    System.err.print("@@@ User chose to press: ");
+	    if(result == CANCEL_OPTION) {
+		System.err.println("cancel");
+	    } else {
+		System.err.println("ok");
+	    }
 	}
     }